Class A_AudioTrigger extends SPActors;

var() string            Song;
var() byte             SongSection;
var() byte             CdTrack;
var() EMusicTransition Transition;
var() bool             bSilence;
var() bool             bOnceOnly;
var() bool             bAffectAllPlayers;

// When gameplay starts.
//function BeginPlay()
//{
//	if( bSilence )
//	{
//		SongSection = 255;
//		CdTrack     = 255;
//	}
//}

// When triggered.
function Trigger(actor Other, pawn EventInstigator)
{
	local SPPawn P;
	local SPPawn A;

	if (bAffectAllPlayers)
	{
		foreach DynamicActors(class'SPPawn', A)
		{
			A.ClientSetMusic( Song, SongSection, CdTrack, Transition );
		}
	}
	else
	{
		// Only affect the one player.
		P = SPPawn(EventInstigator);
		if( P==None )
			return;
			
		// Go to music.
		P.ClientSetMusic( Song, SongSection, CdTrack, Transition );
	}	

	// Turn off if once-only.
	if( bOnceOnly )
	{
		SetCollision(false,false,false);
		disable( 'Trigger' );
	}
}

defaultproperties
{
    CdTrack=255
    Transition=3
    bAffectAllPlayers=True
    bCollideActors=false
}