Class A_CheckPointTrigger extends SPActors placeable;

var() name PreviousPlayerStartTag;
var() name NewPlayerStartTag;
var bool bAlreadyTriggered;

event Trigger(Actor Other, Pawn EventInstigator)
{
	local SPPlayerStart a;
	local PlayerController PC;

	if (!bAlreadyTriggered)
	{

		if (PreviousPlayerStartTag != 'None')
		{
			ForEach AllActors(class'SPPlayerStart', a, PreviousPlayerStartTag)
			{
				a.bEnabled = false;
			}
		}

		if (NewPlayerStartTag != 'None')
		{
			ForEach AllActors(class'SPPlayerStart', a, NewPlayerStartTag)
			{
				a.bEnabled = true;
				Log("Checkpoint Reached.");
			}
		}

		bAlreadyTriggered = true;
	}

	foreach DynamicActors(class'PlayerController', PC)
	{
		if (PC != None && SPGame(Level.Game) != None)
		{
			SPGame(Level.Game).DumpPlayerInfo(PC);
		}
	}

	if (PlayerController(EventInstigator.Controller) != None)
	{
			if (SPGame(Level.Game) != None)
			{
				SPGame(Level.Game).DumpPlayerInfo(PlayerController(EventInstigator.Controller));
			}
	}
}

defaultproperties
{
	bAlreadyTriggered=false
	bHidden=true
}