Class SPDestroyableObject extends Decoration placeable;

var(DestroyableObject) int ExplosionRadius;
var(DestroyableObject) bool bHarmsWhenBlowingUp;
var(DestroyableObject) int DamageAmount;
var class<DamageType> MyDamageType;
var(DestroyableObject) class<actor> ExplodeEffect;

event Trigger(Actor Other, Pawn EventInstigator)
{
	Exploderation();
}

function TakeDamage(int NDamage, Pawn instigatedBy, Vector hitlocation, Vector momentum, class<DamageType> damageType)
{
	local Pawn P;

	Health -= NDamage;
	FragMomentum = Momentum;
	
	if (Health < 0) 	
	{

		if (ExplodeEffect != None)
			Spawn(ExplodeEffect,,, Location);

		if (bHarmsWhenBlowingUp)
		{
			foreach VisibleCollidingActors(class'Pawn', P, ExplosionRadius)
				P.TakeDamage(DamageAmount, None, P.Location, vect(0,0,0), MyDamageType);
		}
		
		bHidden = true;
		SetCollision(false, false, false);
		Destroy();
	}
}

simulated function Exploderation()
{
	SetCollision(false, false, false);
	bHidden = true;
	if (ExplodeEffect != None)
		Spawn(ExplodeEffect,,, Location);

	Destroy();
}

defaultproperties
{
	Health=100
	MyDamageType=Class'SPDT_Explosion'
	DamageAmount=100
	bHarmsWhenBlowingUp=true
	ExplosionRadius=256
     	ExplodeEffect=CodeBase.SPFX_Explosion
	DrawType=DT_StaticMesh
	StaticMesh=StaticMesh'2k4ChargerMeshes.HealthChargerMESH-DS'
     	bStatic=False
     	bWorldGeometry=False
     	bShadowCast=True
	bNoDelete=False
     	bStaticLighting=False
   	CollisionRadius=1.000000
    	CollisionHeight=1.000000
    	bCollideActors=True
    	bBlockActors=True
    	bBlockPlayers=True
    	bBlockKarma=True
}