class SPHackableDevice extends Triggers;

var int Status;
var bool bBeingHacked;
var bool bOn;
var() int StatusIncreasedBy;
var() int HackAmountByTime;
var() bool bResetsWhenNoPlayerPresent;

event Trigger(Actor Other, Pawn EventInstigator)
{
	bOn = true;
}

function bool SelfTriggered()
{
	return true;
}

function UsedBy(Pawn user)
{
	if (bOn)
	{
		TriggerEvent(Event, self, user);
	}

	else
	{
		if (!bBeingHacked)
		{
			bBeingHacked = true;
			user.ClientMessage("Hacking device...");
			SetTimer(HackAmountByTime, true);
		}

		else
		{
			user.ClientMessage("Device is being hacked.");
		}
		
	}
}

function Touch(Actor Other)
{
	if ( Pawn(Other) != None )
	{
	    if(bOn)
		Pawn(Other).ClientMessage("Device has been hacked.");

		else
		{
			if (bBeingHacked)
			{
				Pawn(Other).ClientMessage("Hacking Status:" @Status@ "%");
			}

			else
			{
				Pawn(Other).ClientMessage("Press USE to hack device.");
			}
		}
		

		if (AIController(Pawn(Other).Controller) != None && bOn )
			UsedBy(Pawn(Other));
	}
}

function bool IsRelevant(actor Other)
{
	if (!bOn)
		return false;

	return (Pawn(Other) != None) && Monster(Other) == None;
}

function Timer()
{
	local Pawn P;

	if (bBeingHacked)
	{
		foreach VisibleCollidingActors(class'Pawn', P, CollisionRadius)
		{

			if (P != None)
			{

				if (Status > 99)
				{
					bOn = true;
					bBeingHacked = false;
					SetTimer(0, false);
					P.ClientMessage("Device is now hacked!");
				}

				else				
				{
					P.ClientMessage("Hacking Status:" @Status@ "%");
				}
	
				Status += StatusIncreasedBy;

			}

			else
			{
				if (bResetsWhenNoPlayerPresent)
				{
					Status = 0;
				}
			}
		}
	}
}

defaultproperties
{
	StatusIncreasedBy=5
	HackAmountByTime=1
	bOn=false
	CollisionRadius=50
	CollisionHeight=50
	Status=0
}
