Class SPHealthStation extends Triggers;

var() int UsesLeft;
var() int HealingAmount;
var() sound HealingSound;
var() float TimeUntilReset;

function bool SelfTriggered()
{
	return true;
}

function UsedBy(Pawn user)
{
	if (UsesLeft > 0)
	{
		user.Health += HealingAmount;
		UsesLeft -= 1;
		PlaySound(HealingSound,SLOT_Interact,200,true,180,,true);
	}

	else if (TimeUntilReset > 0)
	{
		SetTimer(TimeUntilReset, false);
	}
}

function Timer()
{
	Super.Timer();

	UsesLeft = default.UsesLeft;
}

function Touch(Actor Other)
{
	if ( Pawn(Other) != None )
	{
		Pawn(Other).ClientMessage("Health Station Uses Remaining:" @UsesLeft);

		if (AIController(Pawn(Other).Controller) != None)
			UsedBy(Pawn(Other));
	}
}

function bool IsRelevant(actor Other)
{

	return (Pawn(Other) != None) && Monster(Other) == None;
}

defaultproperties
{
	HealingSound=Sound'PickupSounds.HealthPack'
	HealingAmount=25
	UsesLeft=10
}