class SPKeycodeDoorPanel extends Triggers;

var() localized string KeyMessage;
var bool bOn;
var() localized string NoKeyMessage;

event Trigger(Actor Other, Pawn EventInstigator)
{
	bOn = true;
}

function bool SelfTriggered()
{
	return true;
}

function UsedBy(Pawn user)
{
	if (bOn)
		TriggerEvent(Event, self, user);
}

function Touch( Actor Other )
{
	if ( Pawn(Other) != None )
	{
	    if(bOn)
		Pawn(Other).ClientMessage(KeyMessage);

		else
			Pawn(Other).ClientMessage(NoKeyMessage);
		

		if (AIController(Pawn(Other).Controller) != None && bOn )
			UsedBy(Pawn(Other));
	}
}

function bool IsRelevant(actor Other)
{
	if (!bOn)
		return false;

	return (Pawn(Other) != None) && Monster(Other) == None;
}

defaultproperties
{
	KeyMessage="You have the key, hit USE to open the door."
	NoKeyMessage="You do not have the correct key to open this door."
	bOn=false
}
