Class SPLevelInfo extends SPActors;

var() string LevelName;
var() string AuthorName;
var() bool bIsATransition;
var() bool bUseInventory;
var() bool bIncreaseDodgeHeight;
var() int DodgeHeight;
var() bool bStartWithShieldGun;
var() bool bUseLightingSystem;
var() bool bAllowSkills;

Struct WeaponLoadout
{
        Var() class<Weapon> WeaponClass;
};

var() array<WeaponLoadout> Weapons;

function LoadMeUp(Pawn P)
{
	local int i;
	local Weapon W;

	if (P != None)
	{
		if (bIncreaseDodgeHeight)
			P.DodgeSpeedZ = DodgeHeight;

		for (i=0; i<Weapons.Length; i++)
		{
			W = Spawn(Weapons[i].WeaponClass);
			if (W != None)
			{
				W.GiveTo(P);
				W.FillToInitialAmmo();
			}
		}

		if (bStartWithShieldGun)
			Spawn(class'ShieldGun').GiveTo(P);
	}
}

defaultproperties
{
	bAllowSkills=true
	bUseLightingSystem=true
	DodgeHeight=400
	bHidden=true
	LevelName="Wibble"
	AuthorName="Wang"
}