Class SPMonsterController extends MonsterController;

var NavigationPoint MT;
var bool bWalksToSpot;

event PostBeginPlay()
{
	Super.PostBeginPlay();

	SetTimer(5, true);
}

function FightEnemy(bool bCanCharge)
{
	local vector X,Y,Z;
	local float enemyDist;
	local float AdjustedCombatStyle, Aggression;
	local bool bFarAway, bOldForcedCharge;
	
	if ( (Enemy == None) || (Pawn == None) )
		log("HERE 3 Enemy "$Enemy$" pawn "$Pawn);

	if ( (Enemy == FailedHuntEnemy) && (Level.TimeSeconds == FailedHuntTime) )
	{
		if ( !Enemy.Controller.bIsPlayer )
			FindNewEnemy();
		
		if ( Enemy == FailedHuntEnemy )
		{
			GoalString = "FAILED HUNT - HANG OUT";
			if ( EnemyVisible() )
				bCanCharge = false;
			else if ( (LastRespawnTime != Level.TimeSeconds) && ((LastSeenTime == 0) || (Level.TimeSeconds - LastSeenTime) > 15) && !Pawn.PlayerCanSeeMe() )
			{
				LastRespawnTime = Level.TimeSeconds;
				EnemyVisibilityTime = 0;
				//foreach AllActors(Class'NavigationPoint', N)
				//{
				//}
			}		
			if ( !EnemyVisible() )
			{
				SPMonster(Pawn).RunAway();
				return;
			}
		}
	}

	bOldForcedCharge = bMustCharge;
	bMustCharge = false;
	enemyDist = VSize(Pawn.Location - Enemy.Location);
	AdjustedCombatStyle = CombatStyle;
	Aggression = 1.5 * FRand() - 0.8 + 2 * AdjustedCombatStyle 
				+ FRand() * (Normal(Enemy.Velocity - Pawn.Velocity) Dot Normal(Enemy.Location - Pawn.Location));
	if ( Enemy.Weapon != None )
		Aggression += 2 * Enemy.Weapon.SuggestDefenseStyle();
	if ( enemyDist > MAXSTAKEOUTDIST )
		Aggression += 0.5;
	if ( (Pawn.Physics == PHYS_Walking) || (Pawn.Physics == PHYS_Falling) )
	{
		if (Pawn.Location.Z > Enemy.Location.Z + TACTICALHEIGHTADVANTAGE) 
			Aggression = FMax(0.0, Aggression - 1.0 + AdjustedCombatStyle);
		else if ( (Skill < 4) && (enemyDist > 0.65 * MAXSTAKEOUTDIST) )
		{
			bFarAway = true;
			Aggression += 0.5;
		}
		else if (Pawn.Location.Z < Enemy.Location.Z - Pawn.CollisionHeight) // below enemy
			Aggression += CombatStyle;
	}

	if ( !EnemyVisible() )
	{
		GoalString = "Enemy not visible";
		if ( !bCanCharge )
		{
			GoalString = "Stake Out";
			DoStakeOut(); 
		}
		else
		{
			GoalString = "Hunt";
			GotoState('Hunting');
		}
		return;
	}
		
	// see enemy - decide whether to charge it or strafe around/stand and fire
	Target = Enemy;
	if( Monster(Pawn).PreferMelee() || (bCanCharge && bOldForcedCharge) )
	{
		GoalString = "Charge";
		DoCharge();
		return;
	}
	
	if ( bCanCharge && (Skill < 5) && bFarAway && (Aggression > 1) && (FRand() < 0.5) )
	{
		GoalString = "Charge closer";
		DoCharge();
		return;
	}

	if ( !Monster(Pawn).PreferMelee() && (FRand() > 0.17 * (skill - 1)) && !DefendMelee(enemyDist) )
	{
		GoalString = "Ranged Attack";
		DoRangedAttackOn(Enemy);
		return;
	}

	if ( bCanCharge )
	{
		if ( Aggression > 1 )
		{
			GoalString = "Charge 2";
			DoCharge();
			return;
		}
	}
	
	if ( !Pawn.bCanStrafe )
	{
		GoalString = "Ranged Attack";
		DoRangedAttackOn(Enemy);
		return;
	}
	
	GoalString = "Do tactical move";
	if ( !Monster(Pawn).RecommendSplashDamage() && Monster(Pawn).bCanDodge && (FRand() < 0.7) && (FRand()*Skill > 3) )
	{
		GetAxes(Rotation,X,Y,Z);
		GoalString = "Try to Duck ";
		if ( FRand() < 0.5 )
		{
			Y *= -1;
			TryToDuck(Y, true);
		}
		else 
			TryToDuck(Y, false);
	}
	DoTacticalMove();
}

function Timer()
{
	if (Enemy == None && SPMonster(Pawn) != None)
	{
		if (fRand() < 0.02)
		{
			WanderOrCamp(false);
		}

		else
		{
			RunAway();
		}
	}
}

function bool FindNewEnemy()
{
	local Pawn BestEnemy;
	local bool bSeeNew, bSeeBest;
	local float BestDist, NewDist;
	//local Controller C;

	local Pawn P;
	local Array<Pawn> O;

	local float SR;

	SetTimer(1, true);

	if (SPMonster(Pawn) != None)
	{
		SR = SPMonster(Pawn).DetectionRadius;
	}

	if (Level.Game.bGameEnded)
		return false;

		foreach VisibleCollidingActors(class'Pawn', P, SR)
		{
			if (P != None && !P.IsA('Monster'))
			{
				O[O.Length] = P;
			}
		}

	if (P != None)
	{
		P = O[RandRange(0, O.Length -1)];
	
		if (BestEnemy == None)
		{
			BestEnemy = P;
			BestDist = VSize(BestEnemy.Location - Pawn.Location);
			bSeeBest = CanSee(BestEnemy);

			if (SPMonster(Pawn) != None && SPMonster(Pawn).bForgetful)
			{
				if (!EnemyVisible())
				{
					RunAway();
				}
			}
		}
	
		else
		{
			NewDist = VSize(P.Location - Pawn.Location);
	
			if (!bSeeBest || (NewDist < BestDist))
			{
				bSeeNew = CanSee(P);
				if ( bSeeNew || (!bSeeBest && (NewDist < BestDist))  )
				{
					BestEnemy = P;
					BestDist = NewDist;
					bSeeBest = bSeeNew;
				}
			}

			if (SPMonster(Pawn) != None && SPMonster(Pawn).bForgetful)
			{
				if (!EnemyVisible())
				{
					RunAway();
				}
			}
		}

	}

	if (BestEnemy == Enemy)
		return false;

	if (BestEnemy != None)
	{
		ChangeEnemy(BestEnemy,CanSee(BestEnemy));
		return true;
	}

	return false;
}

event SeePlayer(Pawn SeenPlayer)
{
	if (SeenPlayer.Visibility < 2)
	{
		bEnemyIsVisible = false;
		return;
	}

	if (((ChooseAttackCounter < 2) || (ChooseAttackTime != Level.TimeSeconds)) && SetEnemy(SeenPlayer))
		WhatToDoNext(3);

	if (Enemy == SeenPlayer)
	{
		VisibleEnemy = Enemy;
		EnemyVisibilityTime = Level.TimeSeconds;
		bEnemyIsVisible = true;
	}
}

function RunAway()
{
	local PathNode P, Prev;
	local Array<PathNode> Y;

	foreach RadiusActors(class'PathNode', P, 1024)
	{
		if (P != None)
		{
			Y[Y.Length] = P;
	
			P = Y[RandRange(0, Y.Length -1)];
		
			if (P.Location == Pawn.Location) // Makes sure the monster does actually move.
			{
				return;
			}

			if (P == Prev) // Stops monster from going to previous pathnode.
			{
				return;
			}
		
			else
			{
				bPreparingMove = true;
				Destination = P.Location;
				GotoState('RestFormation','WaitForAnim');
				Prev = P;
			}
	
		}

		else
		{
			WanderOrCamp(false);
		}

	}
}