class SPMonster_Nali extends SPMonster_FriendlyBase;

function SetMovementPhysics()
{
	SetPhysics(PHYS_Falling); 
}

function PostBeginPlay()
{
	Super.PostBeginPlay();

	SetTimer(5, true);
}

function PlayVictory()
{
	Controller.bPreparingMove = true;
	Acceleration = vect(0,0,0);
	bShotAnim = true;
	Controller.Destination = Location;
	Controller.GotoState('TacticalMove','WaitForAnim');
}

function PlayTakeHit(vector HitLocation, int Damage, class<DamageType> DamageType)
{
	Super.PlayTakeHit(HitLocation, Damage, DamageType);

	RunAway(); // Stop shooting me you bastard!

	return;
}

simulated function Timer()
{
	Super.Timer();

		if (fRand() > 0.8)
		{
			PlaySound(Sound'CodeBaseMonsters.Sounds.nalicry', SLOT_Interact);
			PlayAnim('Bowing');
		}

		else if (fRand() > 0.55)
		{
			PlaySound(Sound'CodeBaseMonsters.Sounds.nalipray', SLOT_Interact);
			SetAnimAction('Levitate');
		}

		else if (fRand() > 0.3)
		{
			PlaySound(Sound'CodeBaseMonsters.Sounds.nalipray', SLOT_Interact);
			SetAnimAction('pray');
		}

		else
		{
			RunAway();
			PlaySound(ChallengeSound[Rand(4)], SLOT_Interact);
		}
}

simulated function PlayDying(class<DamageType> DamageType, vector HitLoc)
{
	AmbientSound = None;
    bCanTeleport = false; 
    bReplicateMovement = false;
    bTearOff = true;
    bPlayedDeath = true;
		
	HitDamageType = DamageType; // these are replicated to other clients
    TakeHitLocation = HitLoc;
	LifeSpan = RagdollLifeSpan;

    GotoState('Dying');
		
	Velocity += TearOffMomentum;
    BaseEyeHeight = Default.BaseEyeHeight;
    SetPhysics(PHYS_Falling);

	PlayAnim('Dead',1.2,0.05);	
}

defaultproperties
{
     bAlwaysStrafe=True
     HitSound(0)=Sound'CodeBaseMonsters.Sounds.nalialtfire'
     HitSound(1)=Sound'CodeBaseMonsters.Sounds.nalialtfire'
     HitSound(2)=Sound'CodeBaseMonsters.Sounds.nalialtfire'
     HitSound(3)=Sound'CodeBaseMonsters.Sounds.nalialtfire'
     DeathSound(0)=Sound'CodeBaseMonsters.Sounds.nalialtfire'
     DeathSound(1)=Sound'CodeBaseMonsters.Sounds.nalialtfire'
     DeathSound(2)=Sound'CodeBaseMonsters.Sounds.nalialtfire'
     DeathSound(3)=Sound'CodeBaseMonsters.Sounds.nalialtfire'
     ChallengeSound(0)=Sound'SkaarjPack_rc.Cow.shakeC'
     ChallengeSound(1)=Sound'SkaarjPack_rc.Cow.swishC'
     ChallengeSound(2)=Sound'SkaarjPack_rc.Cow.shakeC'
     ChallengeSound(3)=Sound'SkaarjPack_rc.Cow.swishC'
     RagImpactSounds(0)=Sound'GeneralImpacts.Wet.Breakbone_01'
     RagImpactSounds(1)=Sound'GeneralImpacts.Wet.Breakbone_02'
     RagImpactSounds(2)=Sound'GeneralImpacts.Wet.Breakbone_03'
     RagImpactSounds(3)=Sound'GeneralImpacts.Wet.Breakbone_04'
     bCrawler=True
     MeleeRange=90.000000
     GroundSpeed=350.000000
     WaterSpeed=300.000000
     JumpZ=300.000000
     Health=120
     		IdleChatAnim="Levitate"
		LandAnims(0) = "Landed"
		LandAnims(1) = "Landed"
		LandAnims(2) = "Landed"
		LandAnims(3) = "Landed"
		AirAnims(0) = "Run"
		AirAnims(1) = "Run"
		AirAnims(2) = "Run"
		AirAnims(3) = "Run"
		WalkAnims(0) = "Walk"
		WalkAnims(1) = "Walk"
		WalkAnims(2) = "Walk"
		WalkAnims(3) = "Walk"
		IdleSwimAnim = "Run"
		IdleWeaponAnim = "Pray"
		IdleRestAnim = "Pray"
		IdleHeavyAnim = "Pray"
		IdleRifleAnim = "Pray"
		AirStillAnim = "Run"
		TakeOffStillAnim = "Run"
		TakeOffAnims(0) = "Run"
		TakeOffAnims(1) = "Run"
		TakeOffAnims(2) = "Run"
		TakeOffAnims(3) = "Run"
		SwimAnims(0) = "Run"
		SwimAnims(1) = "Run"
		SwimAnims(2) = "Run"
		SwimAnims(3) = "Run"
     		IdleCrouchAnim="Bowing"
		DodgeAnims(0) = "Run"
		DodgeAnims(1) = "Run"
		DodgeAnims(2) = "Run"
		DodgeAnims(3) = "Run"
		DoubleJumpAnims(0) = "Run"
		DoubleJumpAnims(1) = "Run"
		DoubleJumpAnims(2) = "Run"
		DoubleJumpAnims(3) = "Run"
		MovementAnims(0) = "Run"
		MovementAnims(1) = "Backup"
		MovementAnims(2) = "Run"
		MovementAnims(3) = "Run"
		TurnLeftAnim = "Run"
		TurnRightAnim = "Run"

     		CrouchAnims(0)="Cringe"
     		CrouchAnims(1)="Cringe"
     		CrouchAnims(2)="Cringe"
     		CrouchAnims(3)="Cringe"
     		CrouchTurnRightAnim="Cringe"
     		CrouchTurnLeftAnim="Cringe"
     		WallDodgeAnims(0)="Run"
     		WallDodgeAnims(1)="Run"
     		WallDodgeAnims(2)="Run"
     		WallDodgeAnims(3)="Run"
     Mesh=VertMesh'CodeBaseMonsters.Nali1'
     CollisionRadius=24.000000
     CollisionHeight=48.000000
     Mass=120.000000
     Skins(0)=Texture'CodeBaseMonsters.Skins.JNali1'
     Skins(1)=Texture'CodeBaseMonsters.Skins.JNali1'
     RotationRate=(Yaw=45000,Roll=0)
}
