class SPMonster_NaliRabbit extends SPMonster;

var name DeathAnims[3];
var bool bLunging;

function SetMovementPhysics()
{
	SetPhysics(PHYS_Falling); 
}

simulated function PlayDirectionalDeath(Vector HitLoc)
{
	PlayAnim(DeathAnims[Rand(3)], 0.7, 0.1);
}

simulated function PlayDirectionalHit(Vector HitLoc)
{
	TweenAnim('TakeHit', 0.05);
}

function PlayVictory()
{
	Controller.bPreparingMove = true;
	Acceleration = vect(0,0,0);
	bShotAnim = true;
	Controller.Destination = Location;
	Controller.GotoState('TacticalMove','WaitForAnim');
}

function RangedAttack(Actor A)
{
	if ( VSize(A.Location - Location) < MeleeRange + CollisionRadius + A.CollisionRadius )
	{
		Controller.Enemy = None;
		RunAway();
	}

	else
	{
		if (fRand() > 0.5)
		{
			PlayAnim('eat', 1);
			PlaySound(ChallengeSound[Rand(4)], SLOT_Interact);
		}

		else
			RunAway();
			PlaySound(ChallengeSound[Rand(4)], SLOT_Interact);
	}
}

defaultproperties
{
     DeathAnims(0)="Call"
     DeathAnims(1)="Call"
     DeathAnims(2)="Call"
     bAlwaysStrafe=True
     HitSound(0)=Sound'CodeBaseMonsters.Sounds.rabbitcall'
     HitSound(1)=Sound'CodeBaseMonsters.Sounds.rabbitcall'
     HitSound(2)=Sound'CodeBaseMonsters.Sounds.rabbitcall'
     HitSound(3)=Sound'CodeBaseMonsters.Sounds.rabbitcall'
     DeathSound(0)=Sound'CodeBaseMonsters.Sounds.rabbitcall'
     DeathSound(1)=Sound'CodeBaseMonsters.Sounds.rabbitcall'
     DeathSound(2)=Sound'CodeBaseMonsters.Sounds.rabbitcall'
     DeathSound(3)=Sound'CodeBaseMonsters.Sounds.rabbitcall'
     ChallengeSound(0)=Sound'CodeBaseMonsters.Sounds.rabbitcall'
     ChallengeSound(1)=Sound'CodeBaseMonsters.Sounds.rabbitcall'
     ChallengeSound(2)=Sound'CodeBaseMonsters.Sounds.rabbitcall'
     ChallengeSound(3)=Sound'CodeBaseMonsters.Sounds.rabbitcall'
     RagImpactSounds(0)=Sound'GeneralImpacts.Wet.Breakbone_01'
     RagImpactSounds(1)=Sound'GeneralImpacts.Wet.Breakbone_02'
     RagImpactSounds(2)=Sound'GeneralImpacts.Wet.Breakbone_03'
     RagImpactSounds(3)=Sound'GeneralImpacts.Wet.Breakbone_04'
     bCrawler=True
     MeleeRange=30.000000
     GroundSpeed=150.000000
     WaterSpeed=300.000000
     JumpZ=300.000000
     Health=100
		LandAnims(0) = "Jump"
		LandAnims(1) = "Jump"
		LandAnims(2) = "Jump"
		LandAnims(3) = "Jump"
		AirAnims(0) = "Jump"
		AirAnims(1) = "Jump"
		AirAnims(2) = "Jump"
		AirAnims(3) = "Jump"
		WalkAnims(0) = "Jump"
		WalkAnims(1) = "Jump"
		WalkAnims(2) = "Jump"
		WalkAnims(3) = "Jump"
		IdleSwimAnim = "Jump"
		IdleWeaponAnim = "Eat"
		IdleRestAnim = "Eat"
		AirStillAnim = "Jump"
		TakeOffStillAnim = "Jump"
		SwimAnims(0) = "Jump"
		SwimAnims(1) = "Jump"
		SwimAnims(2) = "Jump"
		SwimAnims(3) = "Jump"
		CrouchAnims(0) = "Jump"
		CrouchAnims(1) = "Jump"
		CrouchAnims(2) = "Jump"
		CrouchAnims(3) = "Jump"
		MovementAnims(0) = "Jump"
		MovementAnims(1) = "Jump"
		MovementAnims(2) = "Jump"
		MovementAnims(3) = "Jump"
		DoubleJumpAnims(0) = "Jump"
		DoubleJumpAnims(1) = "Jump"
		DoubleJumpAnims(2) = "Jump"
		DoubleJumpAnims(3) = "Jump"
		DodgeAnims(0) = "Jump"
		DodgeAnims(1) = "Jump"
		DodgeAnims(2) = "Jump"
		DodgeAnims(3) = "Jump"
		TurnLeftAnim = "Jump"
		TurnRightAnim = "Jump"
     		IdleChatAnim="Call"
     Mesh=VertMesh'CodeBaseMonsters.Rabbit'
     CollisionRadius=24.000000
     CollisionHeight=24.000000
     Mass=80.000000
     Skins(0)=Texture'CodeBaseMonsters.Skins.JRabbit1'
     Skins(1)=Texture'CodeBaseMonsters.Skins.JRabbit1'
     RotationRate=(Yaw=45000,Roll=0)
}
