class SPMonster_Nalicow extends SPMonster_FriendlyBase;

var name DeathAnims[3];
var bool bLunging;

function PostBeginPlay()
{
	Super.PostBeginPlay();

	SetTimer(5, true);
}

function SetMovementPhysics()
{
	SetPhysics(PHYS_Falling); 
}

simulated function PlayDirectionalDeath(Vector HitLoc)
{
	PlayAnim(DeathAnims[Rand(3)], 0.7, 0.1);
}

simulated function PlayDirectionalHit(Vector HitLoc)
{
	TweenAnim('TakeHit', 0.05);
}

function PlayVictory()
{
	Controller.bPreparingMove = true;
	Acceleration = vect(0,0,0);
	bShotAnim = true;
	Controller.Destination = Location;
	Controller.GotoState('TacticalMove','WaitForAnim');
}

simulated function Timer()
{
	Super.Timer();

		if (fRand() > 0.8)
		{
			PlaySound(ChallengeSound[Rand(4)], SLOT_Interact);
			PlayAnim('root', 1);
		}

		else if (fRand() > 0.55)
		{
			PlaySound(ChallengeSound[Rand(4)], SLOT_Interact);
			PlayAnim('poop', 1);
		}

		else if (fRand() > 0.3)
		{
			PlaySound(ChallengeSound[Rand(4)], SLOT_Interact);
			PlayAnim('chew', 1);
		}

		else
		{
			RunAway();
			PlaySound(ChallengeSound[Rand(4)], SLOT_Interact);
		}
}

defaultproperties
{
     DeathAnims(0)="Dead"
     DeathAnims(1)="Dead2"
     DeathAnims(2)="Dead3"
     bAlwaysStrafe=True
     HitSound(0)=Sound'SkaarjPack_rc.Cow.cMoo1c'
     HitSound(1)=Sound'SkaarjPack_rc.Cow.cMoo2c'
     HitSound(2)=Sound'SkaarjPack_rc.Cow.cMoo2c'
     HitSound(3)=Sound'SkaarjPack_rc.Cow.cMoo1c'
     DeathSound(0)=Sound'SkaarjPack_rc.Cow.DeathC1c'
     DeathSound(1)=Sound'SkaarjPack_rc.Cow.DeathC2c'
     DeathSound(2)=Sound'SkaarjPack_rc.Cow.DeathC1c'
     DeathSound(3)=Sound'SkaarjPack_rc.Cow.DeathC2c'
     ChallengeSound(0)=Sound'SkaarjPack_rc.Cow.shakeC'
     ChallengeSound(1)=Sound'SkaarjPack_rc.Cow.swishC'
     ChallengeSound(2)=Sound'SkaarjPack_rc.Cow.shakeC'
     ChallengeSound(3)=Sound'SkaarjPack_rc.Cow.swishC'
     RagImpactSounds(0)=Sound'GeneralImpacts.Wet.Breakbone_01'
     RagImpactSounds(1)=Sound'GeneralImpacts.Wet.Breakbone_02'
     RagImpactSounds(2)=Sound'GeneralImpacts.Wet.Breakbone_03'
     RagImpactSounds(3)=Sound'GeneralImpacts.Wet.Breakbone_04'
     bCrawler=True
     MeleeRange=120.000000
     GroundSpeed=450.000000
     WaterSpeed=300.000000
     JumpZ=300.000000
     Health=100
     MovementAnims(0)="Run"
     MovementAnims(1)="Run"
     MovementAnims(2)="Run"
     MovementAnims(3)="Run"
     TurnLeftAnim="Run"
     TurnRightAnim="Run"
     WalkAnims(0)="Run"
     WalkAnims(1)="Run"
     WalkAnims(2)="Run"
     WalkAnims(3)="Run"
     AirAnims(0)="Run"
     AirAnims(1)="Run"
     AirAnims(2)="Run"
     AirAnims(3)="Run"
     TakeoffAnims(0)="BigHit"
     TakeoffAnims(1)="BigHit"
     TakeoffAnims(2)="BigHit"
     TakeoffAnims(3)="BigHit"
     DoubleJumpAnims(0)="BigHit"
     DoubleJumpAnims(1)="BigHit"
     DoubleJumpAnims(2)="BigHit"
     DoubleJumpAnims(3)="BigHit"
     DodgeAnims(0)="Run"
     DodgeAnims(1)="Run"
     DodgeAnims(2)="Run"
     DodgeAnims(3)="Run"
     AirStillAnim="Run"
     TakeoffStillAnim="Run"
	IdleSwimAnim = "Run"
	IdleWeaponAnim = "Breath"
	IdleRestAnim = "Poop"
	IdleHeavyAnim = "Root"
	IdleRifleAnim = "Chew"
     TauntAnims(0)="Shake"
     TauntAnims(1)="Swish"
     TauntAnims(2)="Poop"
     TauntAnims(3)="Root"
     TauntAnims(4)="Chew"
     TauntAnims(5)="Breath"
     TauntAnims(6)="Swish"
     TauntAnims(7)="Poop"
     Mesh=VertMesh'SkaarjPack_rc.NaliCow'
     CollisionRadius=24.000000
     CollisionHeight=24.000000
     Mass=80.000000
     Skins(0)=Texture'Skaarjpack_rc.JCow1'
     Skins(1)=Texture'Skaarjpack_rc.JCow1'
     RotationRate=(Yaw=45000,Roll=0)
}
