Class SPMonster_Slith extends SPMonster;

var name MeleeAttack[5];

function ClawDamageTarget()
{
	if (MeleeDamageTarget(15, 21000 * Normal(Controller.Target.Location - Location)))
		PlaySound(sound'CodeBaseMonsters.Sounds.slithmelee',SLOT_Interact);
}

simulated function PlayDying(class<DamageType> DamageType, vector HitLoc)
{
	AmbientSound = None;
    bCanTeleport = false; 
    bReplicateMovement = false;
    bTearOff = true;
    bPlayedDeath = true;
		
	HitDamageType = DamageType; // these are replicated to other clients
    TakeHitLocation = HitLoc;
	LifeSpan = RagdollLifeSpan;

    GotoState('Dying');
		
	Velocity += TearOffMomentum;
    BaseEyeHeight = Default.BaseEyeHeight;
    SetPhysics(PHYS_Falling);

	PlayAnim('Dead1',1.2,0.05);	
}

simulated function PlayDirectionalHit(Vector HitLoc)
{
}

function ShootTarget()
{
	FireProjectile();
}

function RangedAttack(Actor A)
{
	if (bShotAnim)
		return;

	else if ( VSize(A.Location - Location) < MeleeRange + CollisionRadius + A.CollisionRadius )
	{
		PlaySound(sound'CodeBaseMonsters.Sounds.slithmelee',SLOT_Talk);
		SetAnimAction(MeleeAttack[Rand(5)]);
	}	
	else
	{
		SetAnimAction('SHOOT1');
	}
	Controller.bPreparingMove = true;
	Acceleration = vect(0,0,0);
	bShotAnim = true;
}

defaultproperties
{
     MeleeAttack(0)="CLAW1"
     MeleeAttack(1)="CLAW2"
     MeleeAttack(2)="CLAW1"
     MeleeAttack(3)="CLAW2"
     MeleeAttack(4)="CLAW1"
     HitSound(0)=CodeBaseMonsters.Sounds.slithcry
     HitSound(1)=CodeBaseMonsters.Sounds.slithcry
     HitSound(2)=CodeBaseMonsters.Sounds.slithcry
     HitSound(3)=CodeBaseMonsters.Sounds.slithcry
     DeathSound(0)=CodeBaseMonsters.Sounds.slithcry
     DeathSound(1)=CodeBaseMonsters.Sounds.slithcry
     DeathSound(2)=CodeBaseMonsters.Sounds.slithcry
     DeathSound(3)=CodeBaseMonsters.Sounds.slithcry
     ChallengeSound(0)=CodeBaseMonsters.Sounds.slithcry
     ChallengeSound(1)=CodeBaseMonsters.Sounds.slithcry
     ChallengeSound(2)=CodeBaseMonsters.Sounds.slithcry
     ChallengeSound(3)=CodeBaseMonsters.Sounds.slithcry
     FireSound=Sound'CodeBaseMonsters.Sounds.slithhit'
     AmmunitionClass=CodeBase.SlithAmmo
     ScoringValue=2
	Health=120
     TurnLeftAnim="SLITHER"
     TurnRightAnim="SLITHER"
     bCanStrafe=True
     JumpZ=0.000000
     MovementAnims(0)="SURFACE"
     MovementAnims(1)="SURFACE"
     MovementAnims(2)="SURFACE"
     MovementAnims(3)="SURFACE"
     SwimAnims(0)="SWIM"
     SwimAnims(1)="SWIM"
     SwimAnims(2)="SWIM"
     SwimAnims(3)="SWIM"
     WalkAnims(0)="SLITHER"
     WalkAnims(1)="SLITHER"
     WalkAnims(2)="SLITHER"
     WalkAnims(3)="SLITHER"
     AirAnims(0)="DIVE"
     AirAnims(1)="DIVE"
     AirAnims(2)="DIVE"
     AirAnims(3)="DIVE"
     LandAnims(0)="DIVE"
     LandAnims(1)="DIVE"
     LandAnims(2)="DIVE"
     LandAnims(3)="Landed"
     AirStillAnim="DIVE"
     TakeoffStillAnim="DIVE"
     IdleSwimAnim="SWIM"
     IdleWeaponAnim="SLICK"
     IdleRestAnim="SLICK"
     Mesh=VertMesh'CodeBaseMonsters.slith1'
     Skins(0)=Texture'CodeBaseMonsters.Skins.JSlith1'
     Skins(1)=Texture'CodeBaseMonsters.Skins.JSlith1'
     bCanDodge=False
     bCanCrouch=False
	bCanPickupInventory=False

	DetectionRadius=256
	HearingThreshold=256
	SightRadius=4000
	bForgetful=true
}