Class SPMonster_Tentacle extends SPMonster;

var() name TentacleBaseName;

function SetMeUpTent(name SEvent, name STag, int SHealth, name SAITag)
{
	Event = SEvent;
	Tag = STag;

	AIScriptTag = SAITag;

	if (SHealth != 0)
	{
		Health = SHealth;
	}
}

simulated function PlayDying(class<DamageType> DamageType, vector HitLoc)
{
	AmbientSound = None;
    bCanTeleport = false; 
    bReplicateMovement = false;
    bTearOff = true;
    bPlayedDeath = true;
		
	HitDamageType = DamageType; // these are replicated to other clients
    TakeHitLocation = HitLoc;
	LifeSpan = RagdollLifeSpan;

    GotoState('Dying');
		
	Velocity += TearOffMomentum;
    BaseEyeHeight = Default.BaseEyeHeight;
	SetBase(None);
    SetPhysics(PHYS_Falling);
	PlaySound(sound'CodeBaseMonsters.Sounds.tentaclecry',SLOT_Talk);
	PlayAnim('Dead1',1.2,0.05);
}

function RangedAttack(Actor A)
{
	local rotator EnemyRot;

	if (Controller != None) // had to do this otherwise the tentacle wouldn't fire
	{
		EnemyRot = Rotator(Controller.Target.Location - Self.Location);
		SetRotation(EnemyRot);
		Controller.SetRotation(EnemyRot);
	}

	SetAnimAction('Shoot');
	PlaySound(sound'CodeBaseMonsters.Sounds.tentaclefire',SLOT_Talk);
	Controller.bPreparingMove = true;
	Acceleration = vect(0,0,0);
	bShotAnim = true;
}

simulated function AddVelocity(vector NewVelocity)
{
	Velocity = vect(0,0,0);
}

simulated function Timer()
{
	Super.Timer();

	PlaySound(sound'CodeBaseMonsters.Sounds.tentaclealtfire',SLOT_Talk);
	FireProjectile();
	SetPhysics(PHYS_Flying);
}

function SetMovementPhysics()
{
	SetPhysics(PHYS_Flying);

	SetTimer(5, true);
}

defaultproperties
{
	MeleeRange=120
     ScoringValue=5
     CollisionRadius=30.000000
     CollisionHeight=35.000000
     Mesh=VertMesh'CodeBaseMonsters.Tentacle1'
     Skins(0)=Texture'CodeBaseMonsters.Skins.JTentacle1'
     Skins(1)=Texture'CodeBaseMonsters.Skins.JTentacle1'
     bCanDodge=False
     bCanCrouch=False
     AmmunitionClass=Class'TentacleAmmo'
	bCanPickupInventory=False
		GroundSpeed = 0
		WaterSpeed = 0
		AirSpeed = 0
		bCanDoubleJump = False
		bCanWallDodge = False
		bCanDodgeDoubleJump = False
		JumpZ = 0
		LandAnims(0) = "Waver"
		LandAnims(1) = "Waver"
		LandAnims(2) = "Waver"
		LandAnims(3) = "Waver"
		AirAnims(0) = "Waver"
		AirAnims(1) = "Waver"
		AirAnims(2) = "Waver"
		AirAnims(3) = "Waver"
		MovementAnims(0) = "Waver"
		MovementAnims(1) = "Waver"
		MovementAnims(2) = "Waver"
		MovementAnims(3) = "Waver"
		WalkAnims(0) = "Waver"
		WalkAnims(1) = "Waver"
		WalkAnims(2) = "Waver"
		WalkAnims(3) = "Waver"
		IdleSwimAnim = "Waver"
		IdleWeaponAnim = "Waver"
		IdleRestAnim = "Waver"
		AirStillAnim = "Waver"
		TakeOffStillAnim = "Waver"
		SwimAnims(0) = "Waver"
		SwimAnims(1) = "Waver"
		SwimAnims(2) = "Waver"
		SwimAnims(3) = "Waver"
		CrouchAnims(0) = "Waver"
		CrouchAnims(1) = "Waver"
		CrouchAnims(2) = "Waver"
		CrouchAnims(3) = "Waver"
		TakeOffAnims(0) = "Waver"
		TakeOffAnims(1) = "Waver"
		TakeOffAnims(2) = "Waver"
		TakeOffAnims(3) = "Waver"
		DodgeAnims(0) = "Waver"
		DodgeAnims(1) = "Waver"
		DodgeAnims(2) = "Waver"
		DodgeAnims(3) = "Waver"
		TurnLeftAnim = "Waver"
		TurnRightAnim = "Waver"
     		IdleChatAnim="Waver"

	DetectionRadius=1024
	HearingThreshold=1024
	SightRadius=9000
	bForgetful=false
	ControllerClass=Class'SPTentacleController'
}