Class SPPushableObject extends Decoration placeable;

var(PushableObject) bool bDestroyable;
var(PushableObject) int ExplosionRadius;
var(PushableObject) bool bHarmsWhenBlowingUp;
var(PushableObject) int DamageAmount;
var class<DamageType> MyDamageType;
var(PushableObject) class<actor> ExplodeEffect;
var bool bFirstHit;

event Trigger(Actor Other, Pawn EventInstigator)
{
	Exploderation();
}

function Timer()
{
	SetCollision(true, true, true);
}

function StartRotating()
{
	RotationRate.Yaw = 250000*FRand() - 125000;
	RotationRate.Pitch = 250000*FRand() - 125000;
	RotationRate.Roll = 250000*FRand() - 125000;
	DesiredRotation = RotRand();
	bRotateToDesired=False;
	bFixedRotationDir=True;
	bFirstHit=True;
}

singular function Bump(actor Other)
{
	local float speed, oldZ;
	if ((Other.CollisionHeight + CollisionHeight) < ( Other.location.Z - location.Z + 10))
		return;

	if ((Pawn(Other)!=None) && (Other.Mass > 20))
	{
		oldZ = Velocity.Z;
		speed = VSize(Other.Velocity);
		Velocity = Other.Velocity * FMin(120.0, 20 + speed)/speed;
		if (Physics == PHYS_None) 
		{
			Velocity.Z = 25;
			/* if (!bPushSoundPlaying) 
			{
				PlaySound(PushSound, SLOT_Misc);
				bPushSoundPlaying = True;
			} */			
		}
		else
			Velocity.Z = oldZ;
		SetPhysics(PHYS_Falling);
		SetTimer(0.3,False);
		Instigator = Pawn(Other);
	}
}

function Landed(vector HitNormal)
{
	local Rotator NewRot;
	Super.Landed(HitNormal);
	NewRot = Rotation;
	NewRot.Pitch = 18768;
	SetRotation(NewRot);
}

Auto State Animate
{
	function HitWall (vector HitNormal, actor Wall)
	{
		local float speed;

		Velocity = 0.5*(( Velocity dot HitNormal ) * HitNormal * (-2.0) + Velocity);   // Reflect off Wall w/damping
		speed = VSize(Velocity);
		if (bFirstHit && speed<400) 
		{
			bFirstHit=False;
			bRotatetoDesired=True;
			bFixedRotationDir=False;
			DesiredRotation.Yaw=Rand(65535);
			DesiredRotation.Pitch=Rand(65535);
			DesiredRotation.Roll=0;
		}
		RotationRate.Yaw = RotationRate.Yaw*0.75;
		RotationRate.Roll = RotationRate.Roll*0.75;
		RotationRate.Pitch = RotationRate.Pitch*0.75;	
		If (speed < 50) 
		{
			bBounce = False;
			DesiredRotation.Yaw = Rotation.Yaw;
			DesiredRotation.Roll = Rotation.Roll;
			DesiredRotation.Pitch=18768;
			SetRotation(DesiredRotation);
		}
	}	

	event TakeDamage(int Damage, Pawn EventInstigator, vector HitLocation, vector Momentum, class<DamageType> DamageType)
	{
		SetPhysics(PHYS_Falling);
		bBounce = True;
		Velocity += Momentum/Mass;
		Velocity.Z = FMax(Momentum.Z, 200);
		StartRotating();
	}

	singular function Bump(actor Other)
	{
		local float speed, oldZ;
		if ((Other.CollisionHeight + CollisionHeight) < ( Other.location.Z - location.Z + 10))
			return;
	
		if ((Pawn(Other)!=None) && (Other.Mass > 20))
		{
			oldZ = Velocity.Z;
			speed = VSize(Other.Velocity);
			Velocity = Other.Velocity * FMin(120.0, 20 + speed)/speed;
			if (Physics == PHYS_None) 
			{
				Velocity.Z = 25;
				/* if (!bPushSoundPlaying) 
				{
					PlaySound(PushSound, SLOT_Misc);
					bPushSoundPlaying = True;
				} */			
			}
			else
				Velocity.Z = oldZ;
			SetPhysics(PHYS_Falling);
			SetTimer(0.3,False);
			Instigator = Pawn(Other);
		}
	}
}

/* function TakeDamage(int NDamage, Pawn instigatedBy, Vector hitlocation, Vector momentum, class<DamageType> damageType)
{
	local Pawn P;

	Health -= NDamage;
	FragMomentum = Momentum;
	if (bDestroyable)
	{
		if (Health < 0) 	
		{
	
			if (ExplodeEffect != None)
				Spawn(ExplodeEffect,,, Location);
	
			if (bHarmsWhenBlowingUp)
			{
				foreach VisibleCollidingActors(class'Pawn', P, ExplosionRadius)
					P.TakeDamage(DamageAmount, None, P.Location, vect(0,0,0), MyDamageType);
			}
			
			bHidden = true;
			SetCollision(false, false, false);
			Destroy();
		}
	}
} */

function HitWall(vector HitNormal, actor Wall)
{
}

simulated function Exploderation()
{
	SetCollision(false, false, false);
	bHidden = true;
	if (ExplodeEffect != None)
		Spawn(ExplodeEffect,,, Location);

	Destroy();
}

defaultproperties
{
	Mass=10
	// bPushable=true
	bDestroyable=false
	// Health=100
	MyDamageType=Class'SPDT_Explosion'
	DamageAmount=100
	bHarmsWhenBlowingUp=true
	DrawScale=0.25
	ExplosionRadius=256
     	ExplodeEffect=CodeBase.SPFX_Explosion
	DrawType=DT_StaticMesh
	StaticMesh=StaticMesh'Albatross_architecture.Misc.Alb_crate1'
     	bStatic=False
	bCollideWorld=True
     	bShadowCast=True
	bNoDelete=False
     	bStaticLighting=False
   	CollisionRadius=32.000000
    	CollisionHeight=32.000000
    	bCollideActors=True
    	bBlockActors=True
    	bBlockPlayers=True
    	bBlockKarma=True
}