Class SPShop extends Triggers;

var() class<Inventory> ItemToBuy;

var() int CreditCost;
var() string ItemNameToSell;
var() int AmountToSell;
var() sound BuySound;

function bool SelfTriggered()
{
	return true;
}

function UsedBy(Pawn user)
{
	local Inventory Inv;
	local int AmountOf;

	for (Inv = user.Inventory; Inv != None; Inv = Inv.Inventory)
	{
		if (SPCredits(Inv) != None)
		{
			AmountOf = SPCredits(Inv).NumCopies + 1;

			if (AmountOf >= CreditCost)
			{
				Spawn(ItemToBuy).GiveTo(user);

				SPCredits(Inv).NumCopies -= CreditCost;
			}

			else
			{
				if (PlayerController(user.Controller) != None)
				{
					PlayerController(user.Controller).ClientMessage("You do not have enough credit balance.");
				}
			}

			return;
		}
	}

		if (PlayerController(user.Controller) != None)
		{
			PlayerController(user.Controller).ClientMessage("You do not have any credits.");
		}
	
}

function Touch(Actor Other)
{
	if ( Pawn(Other) != None )
	{
		Pawn(Other).ClientMessage("Item:" @ItemNameToSell@ ", Cost:" @CreditCost@ "credits");

		if ( AIController(Pawn(Other).Controller) != None)
			UsedBy(Pawn(Other));
	}
}

function bool IsRelevant(actor Other)
{
	return (Pawn(Other) != None) && Monster(Other) == None;
}

defaultproperties
{
	BuySound=Sound'PickupSounds.HealthPack'
	CreditCost=5
	AmountToSell=5
}